chrome.browserAction.onClicked.addListener(function (activeTab) {
    let popURL = chrome.extension.getURL('popup.html');
    chrome.tabs.query({'url': popURL}, function (tabs) {
        if (!tabs.length) {
            chrome.tabs.create({url: popURL});
        }
        tabs.forEach(function (tab) {
            chrome.tabs.reload(tab.id);
        });
    });

   chrome.tabs.query({'url': 'https://www.instagram.com/*'}, function (tabs) {
        if (!tabs.length) {
            chrome.tabs.create({url: 'https://www.instagram.com/'});
        }
        tabs.forEach(function (tab) {
            chrome.tabs.reload(tab.id);
        });
    });

    let appURL = chrome.extension.getURL('index.html');
    chrome.tabs.query({'url': appURL}, function (tabs) {
        if (!tabs.length) {
            chrome.tabs.create({url: appURL});
        }
        tabs.forEach(function (tab) {
            chrome.tabs.reload(tab.id);
            chrome.tabs.update(tab.id, {active: true});
        });
    });
});

chrome.webRequest.onBeforeSendHeaders.addListener(function (details) {

    if (!localStorage.userAgent) {
        return;
    }

    for (let n in details.requestHeaders) {
        if (details.requestHeaders[n].name.toLowerCase() === "user-agent") {
            details.requestHeaders[n].value = localStorage.userAgent;
            break;
        }
    }

    return {requestHeaders: details.requestHeaders};

}, {
    urls: ["<all_urls>"]
}, ["requestHeaders", "blocking"]);