$(function(){

	db_sql = window.openDatabase('followermonkey_proxy', '', 'FollowerMonkey Proxy', null);

	db_sql.transaction(tx => {
		tx.executeSql("CREATE TABLE IF NOT EXISTS proxy (ip TEXT UNIQUE, port INTEGER, active INTEGER)");
	});

	function getTable(){

		$('#proxies tbody').html("");

		db_sql.transaction(tx => {
			tx.executeSql("SELECT * FROM proxy", [], (ts,result) => {

				if (!result.rows.length) {
					return false;
				}

				for(let i = 0; i<result.rows.length; i++){
					let row = result.rows[i];
					let buttons = '<div class="btn-group" role="group" aria-label="Basic example"> \
								  	<button type="button" class="btn btn-'+(row.active ? 'success':'warning')+' btn-connect" data-ip="'+row.ip+'" data-port="'+row.port+'"><i class="fa fa-check-circle"></i></button> \
								  	<button type="button" class="btn btn-danger delete-ip" data-ip="'+row.ip+'" data-active="'+row.active+'"><i class="fa fa-trash"></i></button> \
								</div>';
					$('#proxies tbody').append('<tr><td><h5>'+row.ip+':<span class="badge badge-info">'+row.port+'</span></h5></td><td class="text-center">'+buttons+'</td></tr>');
				}

			});
		});
	}

	getTable();

	$('#proxy-form').submit(() => {
		let ip = $.trim( $('#proxy_ip').val()),
			port = parseInt($('#proxy_port').val());

			console.log(ip,port);

		db_sql.transaction(ts => {
			ts.executeSql("INSERT INTO proxy (ip, port, active) VALUES ('"+ip+"', "+port+", 0)", null, (tx,err) => {
				console.log(err)
			});
		});

		$(this).trigger('clear');
		getTable();
		return false;
	});

	$('body').on('click', '.delete-ip', function(){
		let ip = $(this).attr('data-ip'),
			isActive = parseInt($(this).attr('data-active'));

		if (isActive) {
			chrome.proxy.settings.clear({});
		}

		db_sql.transaction(ts => {
			ts.executeSql("DELETE FROM proxy WHERE ip='"+ip+"'");
		});

		getTable();
	});

	$('#direct-connect').click(() => {
		db_sql.transaction(ts => {
			ts.executeSql("UPDATE proxy SET active=0");
		});

		getTable();
		localStorage.setItem("setProxy", "0");
		chrome.proxy.settings.clear({});
	});

	$('body').on('click', '.btn-connect', (e) => {
		let ip = $.trim($(e.currentTarget).attr('data-ip')),
			port = parseInt($.trim($(e.currentTarget).attr('data-port')));

		db_sql.transaction(ts => {
			ts.executeSql("UPDATE proxy SET active = 0");
		});

		db_sql.transaction(ts => {
			ts.executeSql("UPDATE proxy SET active = 1 WHERE ip = '"+ip+"'");
		});

		getTable();

		setProxy(ip,port);
	});

	function setProxy(ip,port) {

		localStorage.setItem("setProxy", "1");
	    var config = {
	        mode: "fixed_servers",
	        rules: {
	            singleProxy: {
	                scheme: "http",
	                host: ip,
	                port: parseInt(port)
	            },
                bypassList: ["127.0.0.1", "localhost","[::1]", "*robotwity.com", "*followermonkey.com", "*genderapi.io", "*proxylte.com"]
	        }
	    };

	    chrome.proxy.settings.set({
	            value: config, scope: 'regular'
	        },function(){});
	}

	$('#btn-export').click(function(){

		db_sql.transaction(ts => {
			ts.executeSql("SELECT * FROM proxy", [], (transaction, resultSet) => {
				if (!resultSet.rows.length) {
					return false;
				}

				let data = {};
				for (let i = 0; i < resultSet.rows.length; i++) {
					let row = resultSet.rows[i];
					data["+" + row.ip] = {
                        "bypassList": [
                            {
                                "conditionType": "BypassCondition",
                                "pattern": "<local>"
                            }
                        ],
                        "color": "#99ccee",
                        "fallbackProxy": {
                            "host": row.ip,
                            "port": row.port,
                            "scheme": "http"
                        },
                        "name": row.ip,
                        "profileType": "FixedProfile",
                        "revision": "16855ae8aa6"
					};
				}

				downloadTxt("monkeyProxyBackup.bak", JSON.stringify(data));
			});
		});

	});

	$('#btn-import').click(function(){

        let input = document.getElementById('data-file'),
            reader = new FileReader();

        if (!input.files.length) {
        	alert("Please select a backup file!");
        	return false;
		}

        reader.onload = function () {
            let data = JSON.parse(reader.result);

            if (data) {
            	for (let item in data) {
            		let ipData = data[item];
            		if (ipData.hasOwnProperty("fallbackProxy")){
            			db_sql.transaction(ts => {
            				ts.executeSql("INSERT INTO proxy (ip, port, active)VALUES('"+ipData.fallbackProxy.host+"',"+ipData.fallbackProxy.port+",0)")
						});
					}
				}

				getTable();
			}

			input.value = "";
            $('#modal-import').modal('hide');
        };

        reader.readAsText(input.files[0]);
	});

    function downloadTxt(filename, text) {
        var element = document.createElement('a');
        element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
        element.setAttribute('download', filename);

        element.style.display = 'none';
        document.body.appendChild(element);

        element.click();

        document.body.removeChild(element);
    }
});